#ifndef SNUVI_ERROR_H
#define SNUVI_ERROR_H

#ifdef __cplusplus
extern "C" {
#endif

#include <stdarg.h>
#include <stdbool.h>

typedef struct Error {
    int line;
    char message[256];
} Error;

void eInitError(Error* e, int line, const char* format, ...);
void eInitErrorV(Error* e, int line, const char* format, va_list ap);
void eInitSuccess(Error* e);
bool eHasError(const Error* e);

#ifdef __cplusplus
}
#endif

#endif